org.apache.commons.ssl.asn1

## Class DERUTCTime

- java.lang.Object
- - org.apache.commons.ssl.asn1.ASN1Encodable
  - - org.apache.commons.ssl.asn1.DERObject
    - - org.apache.commons.ssl.asn1.ASN1Object
      - - org.apache.commons.ssl.asn1.DERUTCTime

All Implemented Interfaces:
  DEREncodable, DERTags

    public class DERUTCTime
    extends ASN1Object

UTC time object.

### Field Summary

Fields
`(package private) java.lang.String` `time`

### Fields inherited from class org.apache.commons.ssl.asn1.ASN1Encodable

`BER, DER`

### Fields inherited from interface org.apache.commons.ssl.asn1.DERTags

`APPLICATION, BIT_STRING, BMP_STRING, BOOLEAN, CONSTRUCTED, ENUMERATED, EXTERNAL, GENERAL_STRING, GENERALIZED_TIME, GRAPHIC_STRING, IA5_STRING, INTEGER, NULL, NUMERIC_STRING, OBJECT_IDENTIFIER, OCTET_STRING, PRINTABLE_STRING, SEQUENCE, SEQUENCE_OF, SET, SET_OF, T61_STRING, TAGGED, UNIVERSAL_STRING, UTC_TIME, UTF8_STRING, VIDEOTEX_STRING, VISIBLE_STRING`

### Constructor Summary

Constructors
Constructor and Description
`DERUTCTime(byte[] bytes)`
`DERUTCTime(java.util.Date time)` base constructer from a java.util.date object
`DERUTCTime(java.lang.String time)` The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded.

### Method Summary

Methods
`(package private) boolean` `asn1Equals(DERObject o)`
`(package private) void` `encode(DEROutputStream out)`
`java.util.Date` `getAdjustedDate()` return the time as an adjusted date in the range of 1950 - 2049.
`java.lang.String` `getAdjustedTime()` return a time string as an adjusted date with a 4 digit year.
`java.util.Date` `getDate()` return the time as a date based on whatever a 2 digit year will return.
`static DERUTCTime` `getInstance(ASN1TaggedObject obj, boolean explicit)` return an UTC Time from a tagged object.
`static DERUTCTime` `getInstance(java.lang.Object obj)` return an UTC Time from the passed in object.
`private byte[]` `getOctets()`
`java.lang.String` `getTime()` return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).
`int` `hashCode()`
`java.lang.String` `toString()`

### Methods inherited from class org.apache.commons.ssl.asn1.ASN1Object

`equals, fromByteArray`

### Methods inherited from class org.apache.commons.ssl.asn1.DERObject

`toASN1Object`

### Methods inherited from class org.apache.commons.ssl.asn1.ASN1Encodable

`getDEREncoded, getDERObject, getEncoded, getEncoded`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### time

    java.lang.String time

### Constructor Detail

#### DERUTCTime

    public DERUTCTime(java.lang.String time)

The correct format for this is YYMMDDHHMMSSZ (it used to be that seconds were never encoded. When you're creating one of these objects from scratch, that's what you want to use, otherwise we'll try to deal with whatever gets read from the input stream... (this is why the input format is different from the getTime() method output).

Parameters:
  `time` - the time string.

#### DERUTCTime

    public DERUTCTime(java.util.Date time)

base constructer from a java.util.date object

#### DERUTCTime

    DERUTCTime(byte[] bytes)

### Method Detail

#### getInstance

    public static DERUTCTime getInstance(java.lang.Object obj)

return an UTC Time from the passed in object.

Throws:
  `java.lang.IllegalArgumentException` - if the object cannot be converted.

#### getInstance

    public static DERUTCTime getInstance(ASN1TaggedObject obj,
                         boolean explicit)

return an UTC Time from a tagged object.

Parameters:
  `obj` - the tagged object holding the object we want
  `explicit` - true if the object is meant to be explicitly tagged false otherwise.
Throws:
  `java.lang.IllegalArgumentException` - if the tagged object cannot be converted.

#### getDate

    public java.util.Date getDate()
                           throws java.text.ParseException

return the time as a date based on whatever a 2 digit year will return. For standardised processing use getAdjustedDate().

Returns:
  the resulting date
Throws:
  `java.text.ParseException` - if the date string cannot be parsed.

#### getAdjustedDate

    public java.util.Date getAdjustedDate()
                                   throws java.text.ParseException

return the time as an adjusted date in the range of 1950 - 2049.

Returns:
  a date in the range of 1950 to 2049.
Throws:
  `java.text.ParseException` - if the date string cannot be parsed.

#### getTime

    public java.lang.String getTime()

return the time - always in the form of YYMMDDhhmmssGMT(+hh:mm|-hh:mm).

Normally in a certificate we would expect "Z" rather than "GMT", however adding the "GMT" means we can just use:

         dateF = new SimpleDateFormat("yyMMddHHmmssz");

To read in the time and get a date which is compatible with our local time zone.

Note: In some cases, due to the local date processing, this may lead to unexpected results. If you want to stick the normal convention of 1950 to 2049 use the getAdjustedTime() method.

#### getAdjustedTime

    public java.lang.String getAdjustedTime()

return a time string as an adjusted date with a 4 digit year. This goes in the range of 1950 - 2049.

#### getOctets

    private byte[] getOctets()

#### encode

    void encode(DEROutputStream out)
          throws java.io.IOException

Specified by:
  `encode` in class `ASN1Object`
Throws:
  `java.io.IOException`

#### asn1Equals

    boolean asn1Equals(DERObject o)

Specified by:
  `asn1Equals` in class `ASN1Object`

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `ASN1Object`

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `java.lang.Object`